When you refine String with to_regexp, then it breaks Regexp.try_convert even when the refinement

is not used
Status: Closed   
Assignee:    

Target version:    

ruby -v: 2.2.2p95 Backport: 2.0.0: REQUIRED, 2.1: DONE, 2.2:

DONE

Description

I’ve run into a very strange bug with refinements. Let me show you:

module Ref

  refine String do

    def to_regexp

    end

  end

end

Regexp.try_convert('foo')

# or Regexp.union('foo', 'bar')

 
bug.rb:8:in `try_convert': undefined method `to_regexp' for "foo":String (NoMethodError)

 from test.rb:8:in `<main>'

 Note that the refinement is not used (using), only declared, and yet it has affected behaviour of the refined class! This problem

occurs only when the method is named to_string. It seems that there’s some serious scoping issue with refinements.

I’ve reproduced this issue on MRI 2.2.2p95, 2.1.5p273, and 2.0.0p598.

Associated revisions

Revision a870f4fcfdcd4223ec345b3e0e78959835e2b7a0 - 05/06/2015 01:49 PM - nobu (Nobuyoshi Nakada)

vm_eval.c: undefined refined check_funcall

vm_eval.c (rb_method_call_status): undefined refined method is

not callable unless using.  [ruby-core:69064] [Bug #11117]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@50430 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision a870f4fc - 05/06/2015 01:49 PM - nobu (Nobuyoshi Nakada)

vm_eval.c: undefined refined check_funcall

vm_eval.c (rb_method_call_status): undefined refined method is

not callable unless using.  [ruby-core:69064] [Bug #11117]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@50430 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision bd872a544c1149bbc94d5b3b79066318683fbedd - 05/08/2015 03:11 AM - nobu (Nobuyoshi Nakada)

vm_eval.c: resolve refined method entry

vm_eval.c (rb_method_call_status): resolve refined method entry

to check if undefined.  [ruby-core:69064] [Bug #11117]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@50440 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision bd872a54 - 05/08/2015 03:11 AM - nobu (Nobuyoshi Nakada)

vm_eval.c: resolve refined method entry

vm_eval.c (rb_method_call_status): resolve refined method entry
to check if undefined.  [ruby-core:69064] [Bug #11117]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@50440 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 1bd36e36e09f5bccb5110d197e8494d0d7e19000 - 07/03/2015 08:55 AM - U.Nakamura 

merge revision(s) 50430,50440: [Backport #11117]

    * vm_eval.c (rb_method_call_status): undefined refined method is

      not callable unless using.  [ruby-core:69064] [Bug #11117]

    * vm_eval.c (rb_method_call_status): resolve refined method entry

      to check if undefined.  [ruby-core:69064] [Bug #11117]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_1@51119 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 1bd36e36 - 07/03/2015 08:55 AM - U.Nakamura 

merge revision(s) 50430,50440: [Backport #11117]

    * vm_eval.c (rb_method_call_status): undefined refined method is

      not callable unless using.  [ruby-core:69064] [Bug #11117]

    * vm_eval.c (rb_method_call_status): resolve refined method entry

      to check if undefined.  [ruby-core:69064] [Bug #11117]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_1@51119 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 8ff3a728aea4fb52342839dcfcae6350d6d9a6ec - 07/03/2015 07:44 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 50430,50440: [Backport #11117]

    * vm_eval.c (rb_method_call_status): undefined refined method is

      not callable unless using.  [ruby-core:69064] [Bug #11117]

    * vm_eval.c (rb_method_call_status): resolve refined method entry

      to check if undefined.  [ruby-core:69064] [Bug #11117]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@51133 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 8ff3a728 - 07/03/2015 07:44 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 50430,50440: [Backport #11117]

    * vm_eval.c (rb_method_call_status): undefined refined method is

      not callable unless using.  [ruby-core:69064] [Bug #11117]

    * vm_eval.c (rb_method_call_status): resolve refined method entry

      to check if undefined.  [ruby-core:69064] [Bug #11117]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@51133 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 05/06/2015 01:50 PM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset r50430.

vm_eval.c: undefined refined check_funcall

vm_eval.c (rb_method_call_status): undefined refined method is

not callable unless using.  [ruby-core:69064] [Bug #11117]

#2 - 05/08/2015 04:22 AM - nobu (Nobuyoshi Nakada)

- Priority changed from 5 to Normal

- Backport changed from 2.0.0: UNKNOWN, 2.1: UNKNOWN, 2.2: UNKNOWN to 2.0.0: REQUIRED, 2.1: REQUIRED, 2.2: REQUIRED

#3 - 07/03/2015 08:55 AM - usa (Usaku NAKAMURA)

- Backport changed from 2.0.0: REQUIRED, 2.1: REQUIRED, 2.2: REQUIRED to 2.0.0: REQUIRED, 2.1: DONE, 2.2: REQUIRED
ruby_2_1 r51119 merged revision(s) 50430,50440.

#4 - 07/03/2015 07:45 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.0.0: REQUIRED, 2.1: DONE, 2.2: REQUIRED to 2.0.0: REQUIRED, 2.1: DONE, 2.2: DONE

Backported into ruby_2_2 branch at r51133.

Powered by TCPDF (www.tcpdf.org)

07/17/2025 3/3

http://www.tcpdf.org

